<?php
error_reporting(0);


include_once(dirname(dirname(dirname(__FILE__))) . '/classes/generic.class.php');

class Edit_user extends Generic {

	private $options = array();

	function __construct() {

		// Make sure a user has been selected
		if(!empty($_GET['uid'])) $this->grabCurrentUser(); else parent::displayMessage("<div class='alert alert-error'>"._('No user selected!')."</div>");

		/* Keep track of the original level in case there's a change. We might want to send emails on new level changes. */
		//$this->original_level = is_array($this->options['user_level']) ? serialize($this->options['user_level']) : $this->options['user_level'];

		// Once the form has been processed
		if(!empty($_POST)) {

			// Save all values
			foreach ($_POST as $key => $value)
				$this->options[$key] = parent::secure($value);

			// Validate fields
			$this->validate();

			// Process the form
			echo empty($this->error) ? $this->process() : $this->error;

		}

	}

	private function grabCurrentUser() {

		$this->id = parent::secure($_GET['uid']);

		$params = array( ':pr_id' => $this->id );
		$stmt   = parent::query("SELECT * FROM product WHERE pr_id = :pr_id;", $params);

		if( $stmt->rowCount() < 1 ) parent::displayMessage("<div class='alert alert-error'>"._('No such product!')."</div>");

		foreach ($stmt->fetch(PDO::FETCH_ASSOC) as $field => $value)
			$this->options[$field] = $value;

	}

	public function getLevels() {

		$ids = is_array($this->options['user_level']) ? $this->options['user_level'] : unserialize($this->options['user_level']);
		$placeholder = array_fill(0, count($ids), '?');

		$sql   = "SELECT level_name, level_level FROM product WHERE level_disabled != 1 AND level_level NOT IN (" . implode(',', $placeholder) . ")";
		$stmt2 = parent::query($sql, $ids);

		$sql = "SELECT level_name, level_level FROM product WHERE level_level IN (" . implode(',', $placeholder) . ")";
		$stmt3 = parent::query($sql, $ids);

		?>
		<select class="medium chzn-select" multiple="multiple" id="user_level" name="user_level[]">
			<?php while($level = $stmt3->fetch()) : ?>
			<?php echo $level['level_level'];  ?>
			<option selected="selected" value="<?php echo $level['level_level']; ?>"><?php echo $level['level_name']; ?></option>
			<?php endwhile; ?>
			<?php while($level = $stmt2->fetch()) : ?>
			<option value="<?php echo $level['level_level']; ?>"><?php echo $level['level_name']; ?></option>
			<?php endwhile; ?>
		</select>
		<?php

	}

	private function validate() {

		$this->options['restricted'] = !empty($_POST['restricted']) ? 1 : 0;

		// Checkbox handling
		$fields = parent::getOption('profile-fields');
		if ($fields) :
			foreach(unserialize($fields) as $type => $label) :
				$name = 'p-'.$label;
				if(strstr($type, "checkbox"))
					$this->options[$name] = !empty($this->options[$name]) ? 1 :0;
			endforeach;
		endif;

		// Setting a default user_level if one wasn't selected
		$this->options['user_level'] = empty($_POST['user_level']) ? parent::getOption('default-level') : serialize($this->options['user_level']);

	

		if(empty($this->options['name'])) {
			$this->error = '<div class="alert alert-error">'._('You must enter name.').'</div>';
		}
		if(!empty($this->options['password'])) :
			if($this->options['password'] != $this->options['password2'])
				$this->error = '<div class="alert alert-error">'._('Your passwords did not match.').'</div>';
			if(strlen($this->options['password']) < 5)
				$this->error = '<div class="alert alert-error">'._('Your password must be at least 5 characters.').'</div>';
		endif;
	}

	private function process() {

		if(!empty($this->error))
			return false;

		// Ticked the 'delete user' box?
		if(!empty($this->options['delete'])) {
			$params = array( ':id' => $this->id );
			$sql = "DELETE FROM product WHERE pr_id = :id;";
			parent::query($sql, $params);

			$result = sprintf("<div class='alert alert-success'>"._('User removed from the database:')." <b>%s</b> (%s).</div>",$this->options['name']);
			parent::displayMessage($result);
		}

	
		
			$params = array(
			
				':name'     => $this->options['name'],
				':htname'     => str_replace(' ', '', $this->options['name']),
			':price'     => $this->options['price'],
				':vehicalinformation'     => $_POST['vehicalinformation'],
				':moreinfo'     => $_POST['moreinfo'],
				':category'     => $this->options['category'],
				':displayonbanner'     => $this->options['displayonbanner'],
				':address'     => $this->options['address'],
				
				
				':status'     => $this->options['status'],
				':phone_1'     => $this->options['phone_1'],
				':pname'     => $this->options['pname'],
				':phone_2'     => $this->options['phone_2'],
				':city'     => $this->options['city'],
				':Country'     => $this->options['Country'],
				':email'     => $this->options['email'],
				':State'     => $this->options['State'],
				':categorydats'     => implode(",",$this->options['categorydats']),
				
				':id'       => $this->id
			);
			
			$sql = "UPDATE `product` SET  `name` = :name,`price` = :price,`vehicalinformation` = :vehicalinformation,`moreinfo` = :moreinfo,`catid` = :category,`displayonbanner` = :displayonbanner,`address` = :address,`status` = :status,`phone_1` = :phone_1,`pname` = :pname,`city` = :city,`Country` = :Country,`email` = :email,`State` = :State,`phone_2` = :phone_2 ,`htname` = :htname ,`categorydats` = :categorydats  WHERE `pr_id` = :id;";
			parent::query($sql, $params);
		if($_POST['filecount1']!='')
			{
				for($i=0; $i<count($_POST['filecount1']); $i++)
				{
$cau=parent::query("INSERT INTO `data` ( `data`,`data1`,`pid`,`data2`,`selectlist`)
						VALUES ('".$_POST['data'][$i]."','".$_POST['data1'][$i]."','".$this->id."','".$_POST['data2'][$i]."','".$_POST['selectlist'][$i]."');");

		
				}}
			
			function getFileExtension($str) {
        $i = strrpos($str,".");
        if (!$i) { return ""; }
        $l = strlen($str) - $i;
        $ext = substr($str,$i+1,$l);
        $ext = strtolower($ext);
		
        return $ext;
 		}
		if($_POST['filecount12']!='')
			{
				for($i=0; $i<count($_POST['filecount12']); $i++)
				{ 
				$query=parent::query("update data set data='".$_POST['data10'][$i]."',data1='".$_POST['data11'][$i]."' where id='".$_POST['uid'][$i]."'");
				}
			}
			
			if($_POST['filecount3']!='')
			{
				for($i=0; $i<count($_POST['filecount3']); $i++)
				{ 
			
				$t2	= time().$i;
				$upload2 	= $_FILES[uploada][name][$i];
				if(!empty($upload2))
							{
       							 $ExtImage = getFileExtension($upload2);
	 							 $NewImage3 = "$t2.$ExtImage";
       							 copy($_FILES[uploada][tmp_name][$i], "../banner/$NewImage3");
								 
								 $g= '../banner/'.$NewImage3;
			       				 
								 
								 
							}
						
					$cau=parent::query("INSERT INTO `image` ( `upload`,`pid`)
						VALUES ('".$NewImage3."','".$this->id."');");		
				}}
				?><script type="text/javascript">
<!--
window.location = "product.php"
//-->
</script><?php
				
			//$result = sprintf("<div class='alert alert-success'>"._('User information updated for')." <b>%s</b> (%s).</div>",$this->options['name']);
		

		// Checkbox handling
		$sql  = "SELECT * FROM `login_profile_fields`;";
		$stmt = parent::query($sql);

		while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) :

			$name = 'p-' . $row['id'];

			if($row['type'] == 'checkbox')
				$this->options[$name] = !empty($this->options[$name]) ? 1 :0;

		endwhile;

		// Update profile fields
		foreach($this->options as $field => $value) :

			if(strstr($field,'p-')) {
				$field = str_replace('p-', '', $field);
				parent::updateOption($field, $value, true, $this->options['pr_id']);
			}

		endforeach;

		/* Time to send our welcome email! */
		if ( $this->sendWelcome ) :

			$msg  = parent::getOption('email-welcome-msg');
			$subj = parent::getOption('email-welcome-subj');

			$shortcodes = array(
				'site_address' => SITE_PATH,
				'full_name'    => $this->options['name'],
			
			);

			if(!parent::sendEmail($shortcodes['email'], $subj, $msg, $shortcodes))
				$this->error = _('ERROR. Mail not sent');

		endif;


		return $result;
	}

	// Return a form field
	public function getField($field) {

		if (!empty($this->options[$field]))
			return $this->options[$field];

	}

}