<?php



include_once( 'generic.class.php' );

class Check extends Generic {

	function __construct($forceLogin = true) {

		$this->isGuest($forceLogin);
		$this->isActivated();
		$this->isRestricted();
		$this->forcePwUpdate();

	}


	private function isGuest($forceLogin) {

		if ( !$forceLogin )
			return empty( $_SESSION['leopedia']['user_id'] );

		if ( empty($_SESSION['leopedia']['user_id']) ) :

			$_SESSION['leopedia']['referer'] = $_SERVER['REQUEST_URI'];

			$page = parent::getOption('guest-redirect');
			header('Location: ' . $page);
			exit();

		endif;

	}


	private function isActivated() {

		if ( !empty($_SESSION['leopedia']['activate']) ) :
			header('Location: '. SITE_PATH . 'index.php');
			exit();
		endif;

	}

	private function isRestricted() {

		if ( !empty($_SESSION['leopedia']['restricted']) || !empty($_SESSION['leopedia']['level_disabled']) ) :
			header('Location: '. SITE_PATH . 'disabled.php');
			exit();
		endif;

	}


	private function forcePwUpdate() {

		if ( !empty($_SESSION['leopedia']['forcePwUpdate']) && basename($_SERVER['PHP_SELF']) != 'profile.php') :
			header('Location: '. SITE_PATH . 'profile.php?pe=1');
			exit();
		endif;

	}

	public function protectPage($level) {

	
		$level = array_map( 'trim', explode(",", trim($level)) );

		if( ! @array_intersect($level, $_SESSION['leopedia']['user_level']) && $level != array('*') )
			$this->deny_access();

	}


	public function protectThis($level) {

	
		$level = array_map( 'trim', explode(",", trim($level)) );

		if ( empty( $_SESSION['leopedia']['user_id'] ) && $level == array('*') )
			return false;

		if ( ! @array_intersect($level, $_SESSION['leopedia']['user_level']) && $level != array('*') )
			return false;

		return true;

	}


	private function deny_access() {

		if ( !parent::getOption('block-msg-enable') )
			parent::displayMessage(' ');

		$error = "<div class='row'>
					<div class='span12'>
						" . html_entity_decode(parent::getOption('block-msg')) . "
					</div>
				  </div>";

		parent::displayMessage($error);

	}

}

function protect($level) {

	$check = new Check();
	$check->protectPage($level);

}

function protectThis($level) {

	$check = new Check(false);
	return $check->protectThis($level);

}

